<?php
/*------------------------------------------------------------------------- 
  traffic.php - shows Internet month traffic for employees
  Traffic data is generated by WgLog.exe, LogAn.exe utilities.
  Written by Alexander Selifonov, (c) AS-Works, 2001-2002 
  http://as-works.narod.ru
  Version: 1.04, 20.06.2002

  History:
  1.00 : simple traffic show, for WgLog utility
  1.02 : Email traffic added, LogAn & WgLog can be used to make stats files
  1.03 : WWW-traffic contains "Sent" and "Received fields,
         Detailed traffic (all sites) can be shown
  1.04 : language specifis strings moved to separate php module trf_???.php
  ------------------------------------------------------------------------*/

include "basefunc.php";

// Your language module included here (uncomment one):
include 'trf_rus.php';  // Russian
// include 'trf_eng.php'; // English

HTML_Header($lngTitle);

$mdFile = 'logs/MDstat.ini'; // MDaemon stats for email activity. If empty - no show !
//$mdFile = 'logs/MD-%s.ini';  // if separated stats, %s will be substed with mail domain
$mdList = 'Domains.cfg';	// local mail domain list file (one per line)
$wgFile = "logs/wg.log";	// Wingate main Log file name, generated by WgLog/LogAn
$detFile = "logs/%s.wg";    // Detailed logs fileName template,
                        // %s will be substituted with username: mylogin.wg

$siteFile = "logs/sites-stat.wg"; // Wingate: where is per-site summary stats saved

$ShowListToanybody = 0; // 0 - only admins can see full userList, 1-any user

if(strlen($mdList)>0 && file_exists($mdList) )
{
	$Domains = file($mdList);
	// cut chr(13) at the end of lines:
	for( $iid=0; $iid <count($Domains); $iid++)
	   $Domains[$iid] = rtrim($Domains[$iid]);
}
else
	$Domains = '';

$banned = array(); 
// array for "special" logins, they cannot be viewed by non-admin users

if ($ShowListToanybody == 0)
   GetBannedList();

print "<center><br>";

if (!isset($user)) 
   $user = "";

$admoda = UserIsAdmin();

if(isset($showIPlist))  $showlist = 1;
if(isset($sitestat))  $showlist = 1;

$clr1 = GetColorCode(1);
$clr2 = GetColorCode(2);
$clr4 = GetColorCode(4);

if(!isset($month))
   $month = date("Y.m");

if($user != "" || isset($showlist) ||isset($showIPlist) || isset($detailed) )
{ // show one user traffic
  $traffic = $lngUnknown;
  $show = 1;

  if ($admoda<1 && in_array(strtolower($user), $banned))
    $show = 0;
  if(!isset($month))
      $month = date("Y.m");
  $mnt = '['.$month.']'; // search in section [YYYY.MM]
  if( strpos($user, ".")>0 || isset($showIPlist))
    $mnt = '[IP-'.$month.']'; // searching for IP address, in section [IP-YYYY.MM]


  $summa = 0;

  if($trmode == 2) // Email(MDaemon) traffic
  {
      $datName = str_replace('%s', $mdomain, $mdFile); // MDaemon statistics
//      $datName = str_replace(chr(13), '', $datName);
//      $datName = str_replace(chr(10), '', $datName);
  }
  else
  {
      $datName = $wgFile;
      if(isset($detailed))
      { // Show detailed statistic for desired user
         $user = $detailed;
         $datName = ereg_replace("%s",$user,$detFile);
      }
      if(isset($sitestat))
          $datName = $siteFile;
  }
  echo '<b>';
  if(isset($detailed)) echo $lngDetailed;
  $header1 = $lngH1;
  if($trmode != 2) 
  {
      echo $lngTitle1;
      if(isset($detailed)) 
      {
          echo $lngTitle2.$detailed;
          $header1 = $lngTitle3;
      }
      else if(isset($sitestat))
      {
          echo $lngTitle4; //'Summary statistics for all visited sites';
          $header1 = $lngTitle3; // "Site (URL-address)";
          $detailed = "sites";
      }
  }
  else echo $lngTitle5; //"E-Mail traffic ";
  if(isset($mdomain)) echo '<br>'.$lngTitle7.': '.$mdomain.',<br>';
  echo '<br>'.$lngTitle6.$month."</b><br><br>\n";
  echo "<table width=\"90%\" border=0 cellspacing=2 bgcolor=\"$clr1\"><tr bgcolor=\"$clr2\"><td><b>$header1</b></td>";
        echo '<td><b>'.$lngTitleS.'</b></td><td><b>'.$lngTitleR.'</b></td><td><b>'.$lngTitleSR.'</td><td> </td></tr>';
  if ($show>0 && file_exists($datName))
  { //<2>
    $f = fopen($datName, "r");
    if($f < 1) { HTML_Footer($lngBack, $lngHome,90); exit; }
    $foundMonth = 0;
    while (feof($f) == 0)
    { //<3>
      $strk = ereg_replace("\r?\n", "", fgets($f,1024));
      if(substr($strk,0,1) == "[" )
      {
          if($strk == $mnt) { $foundMonth = 1;     break; }
      }
    } // <3> desired month found

    $nomer = 0;
    if($foundMonth)
    while(feof($f) ==0)
    { //<3>
      $strk = ereg_replace("\r?\n", "", fgets($f,1024));
      if(substr($strk,0,1) == "[") break ; // month data finished
      $eqpos = strpos($strk, "=");
      if($eqpos>0)
      { //<3-a>
        $ps2 = -1;
        $curname = substr($strk,0,$eqpos);
        $traffic = substr($strk, $eqpos+1);
        $ps = strpos($traffic," ");
        if($ps>0)
        {
            $sent = (int) substr($traffic,0,$ps);
            $received = (int) substr($traffic,$ps+1);
            $ps2 = strpos($traffic, '+'); // Detailed report for user generated, so make a link for it
        }
        else
           $received =  $traffic; // old form, without "sent" value

        if(strlen($curname)>0 && ( $curname == $user || isset($detailed) || (isset($showlist) && ($admoda > 0 || $ShowListToanybody) )))
        { //<4>
          $nomer += 1;
          $sumR += $received;
          $sumS += $sent; 
          $itogo = number_format($sent + $received);
          $sent  = number_format($sent);
          $details = "<td> </td>";
          if(!isset($detailed))
            if($ps2>0) $details = "<td><a href=\"$PHP_SELF?month=$month&detailed=$curname\">$lngDetailed</a></td>";
          $received =number_format($received);
          if(isset($detailed) && strpos($curname, '://')>0 ) // show curname as URL for recorder site
             $curname = "<a href=\"$curname\">".str_replace("http://","",$curname)."</a>";
          echo "<tr bgcolor=\"$clr4\"><td><b>$nomer: $curname</b></font></td>";
          echo "<td><b>$sent</b></td><td><b>$received</b></td><td><b>$itogo</b></td>$details</tr>\n";
        } //<4>
      } //<3-a>
    } // <<3>
  } //<2>
  if(isset($showlist) || isset($detailed))
  {
        $itogo = number_format($sumS + $sumR);
        $sumR = number_format($sumR);
        $sumS = number_format($sumS);
        print "<tr bgcolor=\"$clr2\"><td><b>$lngTitleSum</b></font></td>";
        echo "<td><b>$sumS</b></td><td><b>$sumR</b></td><td><b>$itogo</b></td><td> </td></tr>";
  }

  print "</table>";
}

?>
<form action="<?php echo $PHP_SELF?>" method="POST">
<table border=0 cellspacing=2 cellpadding=0 width="90%">
<?PHP

$sel1 = ''; 
$sel2 = '';
if(strlen($mdFile)>0)
{ // show listbox for choosing www/email traffic

    echo "<tr><td width=20%><b>WWW/Email</b></td><td><SELECT NAME=trmode>";
    if($trmode==2) $sel2=" SELECTED"; else $sel1 = " SELECTED";
    echo "<option value=1 $sel1>WWW\n";
    echo "<option value=2 $sel2>E-Mail\n";
    echo "</SELECT></td></tr>\n";
}

if(is_array($Domains))
{ // show mail domains listbox
    echo "<tr><td width=20%><b>$lngTitle7</b></td><td><SELECT NAME=mdomain>";
	if(!isset($mdomain)) $mdomain = $Domains[0]; // default - 1st value selected
	foreach($Domains as $mdname)
	{
      if($mdname==$mdomain) $sel=' SELECTED'; else $sel ='';
      echo "<option value=\"$mdname\"1 $sel>$mdname\n";
	}
    echo "</SELECT></td></tr>\n";
}
?>
<tr><td width=20%><b>Login</td>
<td><input type="text" name="user" value="<?php echo $user?>" length=20>
</td></tr>
<?php

echo "<tr><td><b>$lngTitle8</b></td><td><SELECT NAME=month>";
$curm = date('m');
$cury = date('Y');
if( $month == $cury.".".$curm) $selec = " SELECTED"; 
else $selec = "";

echo "<OPTION VALUE=\"$cury.$curm\" $selec>$lngCurMon\n";
for($ii=1; $ii<6; $ii++)
{
   $curm--; if($curm<1) { $curm=12; $cury--; }
   if($curm<10) $curm = "0".$curm;
   $curdate = $cury.'.'.$curm;
   if( $month == $curdate) 
        $selec = " SELECTED"; 
   else $selec = "";
   echo "<OPTION VALUE=\"$curdate\" $selec>$curm.$cury\n";
}
echo "</SELECT></td></tr>\n";
echo "</table><table border=0 width=90%>\n";
echo '<tr><td>'.SubmitBtn('submit',$lngSubmit);
if(strlen($siteFile)>0 && file_exists($siteFile))
{ // site statistic file exists, so show the button for watch site stat
    echo SubmitBtn('sitestat',$lngAllSit);
}
if (($admoda > 0) || ($ShowListToanybody>0))
{
  echo SubmitBtn('showlist', $lngAllLst);
  echo '</tr><tr><td>'.SubmitBtn('showIPlist',$lngIPLst).'</td>';
}
echo '</table></form>';
HTML_Footer($lngBack, $lngHome,90);
?>
